/******************************************************************************
*
* project name:    TICHESS
* project version: 2.01
* file name:       logout.c
* initial date:    16/03/2000
* author:          thomas.nussbaumer@peem.com
* description:     routines for log output to virtual port
*
* -----------------------------------------------------------------------------
* Revision History
* -----------------------------------------------------------------------------
*
* v1.01: 17/03/2000
*        completely rewritten
*
* v1.00: 16/03/2000
*        initial version
*
******************************************************************************/

#include <mem.h>
#include <string.h>
#include <link.h>

#define LBUFFER_MAX 128

/*===========================================================================*/
/* low level routine to output a binary string to the link port              */
/*                                                                           */
/* NOTE: This routine shouldn't be used directly. Use the macros from        */
/*       logout.h instead                                                    */
/*===========================================================================*/
void _Bin2Link(unsigned long len,const char* msg) {
    unsigned int  idx;
    unsigned int  needed;

    idx = 0;

    while (len > 0) {
        if (len < LBUFFER_MAX) {
            needed = len;
        }
        else {
            needed = LBUFFER_MAX;
        }
        do {
        } while (OSWriteLinkBlock((char*)msg+idx,needed));

        idx += needed;
        len -= needed;
    }
}


/*===========================================================================*/
/* low level routine to output a log message to the link port                */
/*                                                                           */
/* NOTE: This routine shouldn't be used directly. Use the macros from        */
/*       logout.h instead                                                    */
/*===========================================================================*/
void _Log2Link(const char* msg) {
    if (msg == 0) return;
    _Bin2Link(strlen((char*)msg),msg);
}


/*===========================================================================*/
/* low level routine to output a binary string as HEX dump to the link port  */
/*                                                                           */
/* NOTE: This routine shouldn't be used directly. Use the macros from        */
/*       logout.h instead                                                    */
/*===========================================================================*/
void _Hex2Link(unsigned long len,const char* msg) {
//
//
// !!! NOT IMPLEMENTED UNTIL NOW !!!
//
//
}


