/******************************************************************************
*
* project name:    TICHESS
* project version: 2.01
* file name:       logout.h
* initial date:    16/03/2000
* author:          thomas.nussbaumer@peem.com
* description:     header file for using logwriting to link port
*
* -----------------------------------------------------------------------------
* Revision History
* -----------------------------------------------------------------------------
*
* v1.01: 17/03/2000
*        completely revised
*
* v1.00: 16/03/2000
*        initial version
*
******************************************************************************/

#ifndef LOGOUT_H
#define LOGOUT_H

#if ENABLE_LOGGING

void _Log2Link(const char* msg);
void _Bin2Link(unsigned long l,const char* msg);
void _Hex2Link(unsigned long l,const char* msg);


#define LOG2LINK(format,args...) \
{char lob[200]; sprintf(lob,format,##args);_Log2Link((const char*)lob);}

#define BIN2LINK(nr,str) _Bin2Link(nr,(const char*)str)
#define HEX2LINK(nr,str) _Hex2Link(nr,(const char*)str)

#else 

#define LOG2LINK()
#define BIN2LINK()
#define HEX2LINK()

#endif

#endif