/******************************************************************************
*
* project name:    TICHESS
* project version: 2.01
* file name:       ticstart.c
* initial date:    23/03/2000
* author:          Zeljko Juric (zjuric@utic.net.ba)
* description:     launcher for tichess to overcome 8kB limit on AMS 2.03
*
* THANX TO ZELJKO JURIC WHO RELEASES THIS CODE AS PART OF HIS SCOTTFREE DRIVER
* AND GAVE ME PERMISSION TO RE-USE IT
*
* -----------------------------------------------------------------------------
* Revision History
* -----------------------------------------------------------------------------
*
* v1.00: 23/03/2000
*        initial version
*
******************************************************************************/

#include <nostub.h>
#include <alloc.h>
#include <mem.h>
#include <statline.h>
#include <vat.h>

#ifndef AUTO_BUILD
int _ti89, _ti92plus;         // Produce both .89z and .9xz files
#else
#if !TI89_VERSION
#if !TI92_VERSION
#error: Neither "TI89_VERSION" nor "TI92_VERSION" defined
#endif
#endif
#if TI92_VERSION
int _ti92plus;
#endif
#if TI89_VERSION
int _ti89;
#endif
#endif

#define fatal(s) {ST_showHelp(s); return;}

//--------------------------------------------------------------------------
// Note: This program is dirty-written to be as small as possible, so trying
// to understand how it works may be a good brain training for C experts :-)
//--------------------------------------------------------------------------
void _main(void) {
  char *fptr,*cptr;
  unsigned *pptr,*eptr,plen,offs;
  SYM_ENTRY *SymPtr=DerefSym(SymFind($(tichess)));
  if(!SymPtr) fatal("Program not found");

  plen=*(int*)(cptr=fptr=HLock(SymPtr->handle))+3;

  if(SymPtr->flags.bits.archived) {
      if (!(cptr=malloc(plen))) fatal("Out of memory");
      memcpy(cptr,fptr,plen);
  }
  for (eptr=pptr=(unsigned*)(cptr+plen-4);*pptr;pptr-=2);

  while(pptr<eptr) offs = *++pptr, *(char**)(cptr+2+*++pptr) = cptr+0x40002+offs;
  
  ((void(*)())(cptr+0x40002))();

  if(cptr!=fptr) free(cptr);
}

